package require Tk

wm title . " modello led semplificato ver. 0.1"

set xwin 345; # parametro dimensioni x finestra
set ywin 442; # parametro dimensioni y finestra
wm geometry . $xwin\x$ywin+350+200; # la finestra si posiziona alle coordinate x=250 e y=400 dello schermo
wm maxsize . $xwin $ywin
wm minsize . $xwin $ywin

set cf1 {helvetica 10 normal}
set tcl_precision 9

set in_temp_c 25
set in_id1 0.02
set in_id2 0.2
set in_id3 20
set in_vd1 2.439
set in_vd2 2.535
set in_vd3 3.013

#. configure -bg "#BCBCBF"
. configure -bg "#739ca2"

frame .lf1  -width 325 -height 198 -relief groove -border 2 
place configure .lf1 -x 10 -y 34
frame .lf2 -width 325 -height 95 -relief groove -border 2
place configure .lf2 -x 10 -y 265

label .lt1 -width 20 -text "dati da inserire" -font $cf1 -relief groove
place configure .lt1 -x 10 -y 11

label .lt2 -width 20 -text "risultati" -font $cf1 -relief groove
place configure .lt2 -x 10 -y 242

;# widgets frame dati
label .lf1.l1 -width 20 -text "Id1 in mA" -font $cf1
entry .lf1.e1 -validate key -validatecommand {string is double %P} -width 18 -textvariable in_id1 -justify right -font "helvetica 10"
place configure .lf1.l1 -x 10 -y 10
place configure .lf1.e1 -x 180 -y 9

label .lf1.l2 -width 20 -text "Vd1 in V" -font $cf1
entry .lf1.e2 -validate key -validatecommand {string is double %P} -width 18 -textvariable in_vd1 -justify right -font "helvetica 10"
place configure .lf1.l2 -x 10 -y 36 ;#+26
place configure .lf1.e2 -x 180 -y 35 ;#+26

label .lf1.l3 -width 20 -text "Id2 in mA" -font $cf1
entry .lf1.e3 -validate key -validatecommand {string is double %P} -width 18 -textvariable in_id2 -justify right -font "helvetica 10"
place configure .lf1.l3 -x 10 -y 62
place configure .lf1.e3 -x 180 -y 61

label .lf1.l4 -width 20 -text "Vd2 in V" -font $cf1
entry .lf1.e4 -validate key -validatecommand {string is double %P} -width 18 -textvariable in_vd2 -justify right -font "helvetica 10"
place configure .lf1.l4 -x 10 -y 88
place configure .lf1.e4 -x 180 -y 87

label .lf1.l5 -width 20 -text "Id3 in mA" -font $cf1
entry .lf1.e5 -validate key -validatecommand {string is double %P} -width 18 -textvariable in_id3 -justify right -font "helvetica 10"
place configure .lf1.l5 -x 10 -y 114
place configure .lf1.e5 -x 180 -y 113

label .lf1.l6 -width 20 -text "Vd3 in V" -font $cf1
entry .lf1.e6 -validate key -validatecommand {string is double %P} -width 18 -textvariable in_vd3 -justify right -font "helvetica 10"
place configure .lf1.l6 -x 10 -y 140
place configure .lf1.e6 -x 180 -y 139

label .lf1.l7 -width 20 -text "Temperatura in C" -font $cf1
entry .lf1.e7 -validate key -validatecommand {string is double %P} -width 18 -textvariable in_temp_c -justify right -font "helvetica 10"
place configure .lf1.l7 -x 10 -y 166
place configure .lf1.e7 -x 180 -y 165

;# widgets frame risultati
label .lf2.l8 -width 20 -text "N" -font $cf1
entry .lf2.l9 -width 18 -textvariable val5 -font $cf1 -justify right -relief groove -state readonly
place configure .lf2.l8 -x 10 -y 10
place configure .lf2.l9 -x 180 -y 9

label .lf2.l10 -width 20 -text "Is in Ampere" -font $cf1
entry .lf2.l11 -width 18 -textvariable val6  -font $cf1 -justify right -relief groove -state readonly
place configure .lf2.l10 -x 10 -y 36 ;#+26
place configure .lf2.l11 -x 180 -y 35 ;#+26

label .lf2.l12 -width 20 -text "Rs in Ohm" -font $cf1
entry .lf2.l13 -width 18 -textvariable val7 -font $cf1 -justify right -relief groove -state readonly
place configure .lf2.l12 -x 10 -y 62
place configure .lf2.l13 -x 180 -y 61


button .b1 -width 12 -text "calcola"  -font $cf1 -command  {calc0 $in_id1 $in_vd1 $in_id2 $in_vd2 $in_id3 $in_vd3 $in_temp_c}
button .b2 -width 12 -text "uscita"   -font $cf1 -command {destroy .}

place configure .b1 -x 30 -y 398
place configure .b2 -x 205 -y 398

proc calc0 {in_id1 in_vd1 in_id2 in_vd2 in_id3 in_vd3 in_temp_c} {
    global val5 val6 val7 val8
    
    set T [expr ($in_temp_c + 273.15)]
    set q [expr (1.602E-19)]
    set k [expr (1.38E-23)]
    set vt [expr ($k * $T / $q)]
    set N [expr (($in_vd2 - $in_vd1) / ($vt * log($in_id2/$in_id1)))]
    set Is [expr (($in_id1 * 0.001) / ( exp( $in_vd1 / ($vt * $N))))]
    set Rs [expr ($in_vd3 - log(($in_id3 * 0.001) / $Is) * $N * $vt) / ($in_id3 * 0.001)]
    set val5 [format %8.5f $N]
    set val6 [format %8.5E $Is]
    set val7 [format %6.3f $Rs]
    set val8 [format %8.5f $vt]
}
